###
### FIXME
###

FIND_PATH(Loki_INCLUDE_DIRS LokiExport.h /usr/include/loki /usr/local/include/loki)

FIND_LIBRARY(Loki_LIBRARIES NAMES loki PATH /usr/lib /usr/local/lib) 

IF (Loki_INCLUDE_DIRS AND Loki_LIBRARIES)
   SET(Loki_FOUND TRUE)
ENDIF ()

IF (Loki_LIBRARIES MATCHES "(\\.a|loki\\.lib)$")
   SET(Loki_TYPE STATIC_LIBRARY)
   SET(Loki_DEFINITIONS "-DLOKI_STATIC")
ELSE ()
   SET(Loki_TYPE SHARED_LIBRARY)
   SET(Loki_DEFINITIONS "-DLOKI_DLL")
ENDIF ()

IF (Loki_FOUND)
   IF (NOT Loki_FIND_QUIETLY)
      MESSAGE(STATUS "Found Loki: ${Loki_LIBRARIES}")
   ENDIF (NOT Loki_FIND_QUIETLY)
ELSE (Loki_FOUND)
   IF (Loki_FIND_REQUIRED)
      MESSAGE(FATAL_ERROR "Could not find Loki-lib")
   ENDIF (Loki_FIND_REQUIRED)
ENDIF (Loki_FOUND)

MARK_AS_ADVANCED(Loki_INCLUDE_DIRS Loki_LIBRARIES)
