
#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <memory>

#include <core/optimization_criterion.hpp>
#include <core/time_measurement.hpp>

namespace hype{
	namespace core{


class WaitingTimeAwareResponseTime : public OptimizationCriterion{

	public:
	WaitingTimeAwareResponseTime(const std::string& name_of_operation);

	virtual const SchedulingDecision getOptimalAlgorithm_internal(const Tuple& input_values, Operation& op, DeviceTypeConstraint dev_constr);
//OptimizationCriterionFactorySingleton::Instance().

	static WaitingTimeAwareResponseTime* create(){
		return new WaitingTimeAwareResponseTime("");
	}

};


	}; //end namespace core
}; //end namespace stemod



