
#pragma once

//#include <core/scheduling_decision.hpp>

//#include <boost/shared_ptr.hpp>

#include <query_processing/operator.hpp>
//#include <util/iostream.hpp>

namespace hype
{
	namespace queryprocessing
	{

	/*! \todo add query id to operator, so it can be easily identified, which query an operator belongs to*/

		template <typename Type>
		class TypedOperator : public hype::queryprocessing::Operator{
			public:
			typedef Type OperatorOutputType;


			TypedOperator(const hype::SchedulingDecision& sched_dec) : Operator(sched_dec),result_(){}

			virtual ~TypedOperator(){}

			const OperatorOutputType getResult(){
				//this(); //execute Functor
				return result_;
			}

			virtual bool run() = 0;

			virtual void print(unsigned int tree_level=0) const = 0;

			//virtual std::list<TypedOperator&> getOperatorQueue() = 0;

			protected:
			OperatorOutputType result_;
		};
		
	}; //end namespace queryprocessing
}; //end namespace stemod
