
#pragma once

#include <string>
#include <config/global_definitions.hpp>

namespace hype{
	namespace util{

	const std::string getName(StatisticalMethods::StatisticalMethod);
	const std::string getName(RecomputationHeuristics::RecomputationHeuristic);
	const std::string getName(OptimizationCriterions::OptimizationCriterion);	
	const std::string getName(ProcessingDeviceType);		
	
	}; //end namespace util
}; //end namespace hype

