#include <hype.h>



int main(){

 stemod_operation_addAlgorithm("SORT","BubbleSort","LEAST_SQUARES","PERIODIC");

	if(!stemod_operation_optimization_criterion_set("SORT","RESPONSE TIME")) printf("Error\n");

	if(!stemod_operation_optimization_criterion_set("MERGE","Throughput")) printf("Error\n");



	if(!stemod_algorithm_statistical_method_set("Quicksort","LEAST_SQUARES")) printf("Error\n");

	if(!stemod_algorithm_statistical_method_set("Bubblesort","SPLINES")) printf("Error\n");



	if(!stemod_algorithm_recomputation_heuristic_set("Quicksort","EVENTBASED")) printf("Error\n");

	if(!stemod_algorithm_recomputation_heuristic_set("Bubblesort","PERIODIC")) printf("Error\n");



	char* algorithm_name = stemod_scheduler_OptimalAlgorithmName_get("SORT");



	struct C_AlgorithmMeasurement c_algmeasure;



	double values[2];

	values[0]=1;

	values[1]=3;



	stemod_algorithm_measurement_before_execution(&c_algmeasure,"Mergesort",values,sizeof(values)); //starts timer



	//stemod_algorithm_measurement_before_execution(&c_algmeasure);



	stemod_algorithm_measurement_after_execution(&c_algmeasure);


return 0;
}

