
#include <core/statistical_method.hpp>
#include <core/algorithm.hpp>

namespace hype{
	namespace core{


	StatisticalMethod::StatisticalMethod(const std::string& name) : name_(name){
	}

	

const std::tr1::shared_ptr<StatisticalMethod> getNewStatisticalMethodbyName(std::string name){

	//StatisticalMethodFactory aFactory;
	StatisticalMethod* ptr = StatisticalMethodFactorySingleton::Instance().CreateObject(name); //.( 1, createProductNull );
	return std::tr1::shared_ptr<StatisticalMethod> (ptr);
//3. aFactory.CreateObject( 1 ); 
}

StatisticalMethodFactory& StatisticalMethodFactorySingleton::Instance()
{
	static StatisticalMethodFactory factory;
	return factory;
}
	};//end namespace core
}; //end namespace stemod

